<template>
  <q-page class="user-page">
    <div>
      <h1 class="page-title text-h4">User Management System</h1>
    </div>
    <q-table
      :columns="columns"
      :rows="rows"
      align="left"
      separator="horizontal"
      table-class="my-special-class"
    >
      <template v-slot:body="props">
        <q-tr :props="props">
          <q-td class="table-data" key="name">
            {{ new Date(props.row.date).toLocaleDateString() }}
          </q-td>
          <q-td class="table-data" key="name">
            {{ props.row.name }}
          </q-td>
          <q-td key="username"> @{{ props.row.username }} </q-td>
          <q-td key="email">
            {{ props.row.email }}
          </q-td>
          <q-td key="address">
            {{
              props.row.address.street +
              "\n" +
              props.row.address.suite +
              "--" +
              props.row.address.city +
              " - " +
              props.row.address.zipcode
            }}
          </q-td>
          <q-td key="phone">
            {{ props.row.phone }}
          </q-td>
          <q-td key="name">
            <q-btn
              color="primary"
              label="Update"
              @click="setUserToUpdate(props.row)"
              to="/add-users"
            ></q-btn>
          </q-td>
          <q-td key="name">
            <q-btn
              @click="
                () => {
                  confirmation = true;
                  userToDelete = props.row;
                }
              "
              color="negative"
              label="Delete"
            ></q-btn>
          </q-td>
          <q-td key="name">
            <q-btn
              color="secondary"
              label="View Details"
              @click="viewDetails(props.row)"
            ></q-btn>
          </q-td>
        </q-tr>
      </template>
    </q-table>
  </q-page>

  <q-dialog v-model="alert">
    <q-card tag="div" class="q-card">
      <q-card-section>
        <div class="text-h5 text-green-10">{{ selectedRow.name }}</div>
      </q-card-section>

      <q-separator />

      <q-card-section class="q-pt-5 q-pl-0">
        <h1 class="text-h5 q-pa-none text-green-10 text-bold">
          Contact Details
        </h1>
        <div class="column q-gutter-none">
          <q-card-section class="q-pa-none">
            <span class="text-subtitle1 text-weight-bold">Username: </span>
            <span>{{ selectedRow.username }}</span>
          </q-card-section>
          <q-card-section class="q-pa-none">
            <span class="text-subtitle1 text-weight-bold">Email: </span>
            <span>{{ selectedRow.email }}</span>
          </q-card-section>
          <q-card-section class="q-pa-none">
            <span class="text-subtitle1 text-weight-bold">Phone Number: </span>
            <span>{{ selectedRow.phone }}</span>
          </q-card-section>
          <q-card-section class="q-pa-none">
            <span class="text-subtitle1 text-weight-bold">Website: </span>
            <span>{{ selectedRow.website }}</span>
          </q-card-section>
        </div>
      </q-card-section>

      <q-separator />

      <q-card-section class="q-pt-xs">
        <h1 class="text-h5 q-pa-none text-green-10 text-bold">Address</h1>
        <div class="column q-gutter-none">
          <q-card-section class="q-pa-none">
            <span class="text-subtitle1 text-weight-bold">Street: </span>
            <span>{{ selectedRow.address.street }}</span>
          </q-card-section>
          <q-card-section class="q-pa-none">
            <span class="text-subtitle1 text-weight-bold">Suite: </span>
            <span>{{ selectedRow.address.suite }}</span>
          </q-card-section>
          <q-card-section class="q-pa-none">
            <span class="text-subtitle1 text-weight-bold">City: </span>
            <span>{{ selectedRow.address.city }}</span>
          </q-card-section>
          <q-card-section class="q-pa-none">
            <span class="text-subtitle1 text-weight-bold">ZIP Code: </span>
            <span>{{ selectedRow.address.zipcode }}</span>
          </q-card-section>
        </div>
      </q-card-section>

      <q-separator />

      <q-card-section class="q-pt-xs">
        <h1 class="text-h5 q-pa-none text-green-10 text-bold">Company</h1>
        <div class="column q-gutter-none">
          <q-card-section class="q-pa-none">
            <span class="text-subtitle1 text-weight-bold">Company Name: </span>
            <span>{{ selectedRow.company.name }}</span>
          </q-card-section>
          <q-card-section class="q-pa-none">
            <span class="text-subtitle1 text-weight-bold">Catch phrase: </span>
            <span>{{ selectedRow.company.catchPhrase }}</span>
          </q-card-section>
          <q-card-section class="q-pa-none">
            <span class="text-subtitle1 text-weight-bold">BS: </span>
            <span>{{ selectedRow.company.bs }}</span>
          </q-card-section>
        </div>
      </q-card-section>

      <q-separator />

      <q-card-actions align="right">
        <q-btn flat label="Close" color="primary" v-close-popup />
      </q-card-actions>
    </q-card>
  </q-dialog>

  <q-dialog v-model="confirmation">
    <q-card tag="div" class="confirmation">
      <q-card-section v-if="deleteLoading" class="column items-center">
        <div class="text-h6">Deleting User...</div>
        <q-circular-progress
          indeterminate
          rounded
          size="50px"
          color="positive"
          class="q-ma-md"
        />
      </q-card-section>

      <q-card-section v-if="!deleteLoading">
        <div class="text-h6 text-red-10">
          Are you sure you want to remove this user?
        </div>
        <div class="text-weight-bold text-h6 text-green-10">
          {{ userToDelete.name }}
        </div>
      </q-card-section>

      <q-card-actions v-if="!deleteLoading" align="right" class="q-pr-md">
        <q-btn
          flat
          label="Cancel"
          class="bg-green-10 text-white"
          v-close-popup
        />
        <q-btn
          label="Remove"
          color="negative"
          @click="
            () => {
              deleteLoading = true;
              deleteUser(userToDelete.id);
            }
          "
        />
      </q-card-actions>
    </q-card>
  </q-dialog>
</template>
<script>
import { ref } from "vue";
import { columns } from "../composables/userColumns";
import {
  rows,
  getUsers,
  deleteUser,
  deleteLoading,
  confirmation,
  setUserToUpdate,
} from "../composables/users.js";
export default {
  name: "UsersPage",

  setup() {
    let alert = ref(false);
    let selectedRow = ref(null);

    let userToDelete = ref(null);

    let viewDetails = (row) => {
      alert.value = true;

      selectedRow.value = row;

      console.log(selectedRow);
    };

    getUsers();

    return {
      rows,
      columns,
      alert,
      viewDetails,
      selectedRow,
      deleteUser,
      confirmation,
      userToDelete,
      deleteLoading,
      setUserToUpdate,
    };
  },
};
</script>

<style lang="scss">
.user-page {
  padding: 1rem;
}
.page-title {
  color: #0a421f;
  font-weight: bold;
}
.q-table {
  th {
    background: #0a421f;
    color: white;
    font-size: 1.1rem;
  }
}

.q-card {
  max-width: 30rem;
  width: 100%;
}

.confirmation {
  max-width: 20rem;
  width: 100%;
}
</style>
